'created 01/02/92
'updated 09/09/93
'*******************
DEFINT A-Z
REM $INCLUDE: 'KELLY3.INC'

' Utility routines
'make an error beep
DECLARE SUB MakeBeepSound ()
'update the display
DECLARE SUB PrintResults ()
'displays an array of one month calendars
DECLARE SUB ShowCalendar ()

	TVideo% = VIDEOSTAT%      'determine CRT type
   
	'if have a vga, make sure in correctmode
	IF VGAFIXTEXT THEN TVideo% = -10
	
	Cmd$ = COMMAND$
	IF LEN(Cmd$) THEN     'allow user to change defaults
		IF INSTR(Cmd$, "/B") THEN TVideo% = 0
		IF INSTR(Cmd$, "/C") THEN TVideo% = 2
	END IF
    
	TYPE WindowType               'holds dimensions of box
		ULR AS INTEGER
		ULC AS INTEGER
		LRR AS INTEGER
		LRC AS INTEGER
	END TYPE
	CONST MaxBoxes% = 3

	'Limit the characters that can be inputted by the following string
	NumFilter$ = "01234567890,-"

	'Other message strings commonly used
	 InputErrMsg$ = "Input error, invalid date"
	 TryAgainMsg$ = "Insufficient input, try again."
	  OutofRange$ = "Days between Date value out of range!"
	 MonthPrompt$ = "Month: ? ": DayPrompt$ = "Day:   ? "
	  YearPrompt$ = "Year:  ? "
 DaytnDatesPrompt$ = "Number of days between dates? "
	InputMessage$ = "INPUT AREA"
		   Year$ = "  Year(s)"
	
	 DIM SHARED WBx(1 TO MaxBoxes%)  AS WindowType
	
	 WBx(1).ULR = 3
	 WBx(1).ULC = 11
	 WBx(1).LRR = WBx(1).ULR + 3
	 WBx(1).LRC = WBx(1).ULC + 18

	 WBx(2).ULR = WBx(1).ULR
	 WBx(2).ULC = WBx(1).ULC + 41
	 WBx(2).LRR = WBx(2).ULR + 3:
	 WBx(2).LRC = WBx(2).ULC + 18

	 WBx(3).ULR = WBx(1).ULR + 6
	 WBx(3).ULC = (WBx(2).ULC - WBx(1).ULC) \ 2 + WBx(1).ULC - 1
	 WBx(3).LRR = WBx(3).ULR + 3:
	 WBx(3).LRC = WBx(3).ULC + 22

	 WIDTH 80, 25         'make sure get defualt video setup
	 CALL SNOWCHECK       'turn off snow checking if have good CGA display
	
	 LOCATE , , 0         'turn off cursor
	
	 'save keyboard state and turn on numlock
	 CALL GETKBD(Insertk%, CapsLk%, NumLk%, ScrolK%)
	 OrigNumLk% = NumLk%
	 NumLk% = 1  'turn on num lock
	 CALL SETKBD(Insertk%, CapsLk%, NumLk%, ScrolK%)

	 SELECT CASE TVideo%      'select pleasing colors
		CASE -3, -2, 0, 3, 4, 10, -10, -11
		'color does not work well on mono, Herc, COMPAQ or AT&T
			ClrAttrib% = &H7:  ATTRIB% = &H7: ClockCol% = 0
		CASE ELSE
			ClrAttrib% = &H17: ATTRIB% = &H30: ClockCol% = &H20
	 END SELECT
	
	'draw main box  w/o changing center area
	CALL MAKEBOXES(1, 1, 25, 80, 0, 3, &H70)
	T1$ = "[Date Utility (C) Copr. 1993 - S.J. Kelly]"
	CALL QPRINT(1, 20, T1$, &H70)             'print title
	CALL KILLSTRING(T1$)                      'save some string space
    
	'clear center area to attactive color  'CLS substitute
	CALL BACKFILL(2, 2, 24, 79, ClrAttrib%, 32)

	CALL ShowCalendar     'show 6 months around current month
    
	'clear center area to attactive color  'CLS substitute
	CALL BACKFILL(2, 2, 24, 79, ClrAttrib%, 32)

	'print help information
	T2$ = " [F1 = 1ST Date,  F2 = 2ND Date, F3 = Days Between Dates, F4 = Clear Next] "
	CALL QPRINT(23, 3, T2$, ATTRIB%)          'print message
	CALL KILLSTRING(T2$)                      'save some string space
    
	T3$ = " Hold ALT key with Function key to Recalculate.  ESC key Quits. "
	CALL QPRINT(24, 9, T3$, ATTRIB%)
	CALL KILLSTRING(T3$)                      'save some string space

	FOR x = 1 TO MaxBoxes%     'draw the subsidiary boxes w/ shadows
		CALL MAKEBOXES(WBx(x).ULR, WBx(x).ULC, WBx(x).LRR, WBx(x).LRC, 0, 258, &H70)
	NEXT

	T4$ = " F1 - Start Date "  'add label
	CALL QPRINT(WBx(1).ULR, WBx(1).ULC + 1, T4$, &H70)
	CALL KILLSTRING(T4$)                      'save some string space

	T5$ = " F2 -  End Date  "   'add label
	CALL QPRINT(WBx(2).ULR, WBx(2).ULC + 1, T5$, &H70)
	CALL KILLSTRING(T5$)                      'save some string space

	T6$ = " F3 -  Days--Dates "  'add label
	CALL QPRINT(WBx(3).ULR, WBx(3).ULC + 1, T6$, &H70)
	CALL QPRT(WBx(3).ULR + 2, WBx(3).LRC - 11, Year$)
	CALL KILLSTRING(T6$)                      'save some string space

	StartRow% = WBx(3).LRR + 4        'where to begin to seek input
	CALL PrintResults                 'display default information
    
	CALL QPRINT(StartRow% - 2, 12, InputMessage$, &H70)
	CALL QPRT(StartRow%, 3, MonthPrompt$)
	CALL QPRT(StartRow% + 1, 3, DayPrompt$)
	CALL QPRT(StartRow% + 2, 3, YearPrompt$)
	CALL QPRT(StartRow% + 3, 3, DaytnDatesPrompt$)
	
	ClearNext = -1          'a toggle flag for use w/ F4 key
    
	'install clock
	InstallMode% = 1:
	CALL SHOWCLOCK(5, WBx(3).ULC + 5, ClockCol%, InstallMode%)
	CALL MAKEBOXES(4, WBx(3).ULC + 4, 6, WBx(3).ULC + 16, 0, 257, ClockCol%)


'============Main routine starts here==============
DO
	 KeyItem% = WAITFORKEY%

	 SELECT CASE KeyItem%
		  CASE -256           'no key pressed
		  CASE 27, 3, -3, 0   'ESCAPE key, BREAK key
			   EXIT DO       'quit program
		  CASE -59            'F1, input day one
ReStart1:
			IF ClearNext THEN
				CALL KILLSTRING(Month1$)
			ELSE
				Month1$ = MID$(Date1$, 1, 2)
			END IF
			A$ = EDITOR$(StartRow%, 12, 2, &H70, Month1$, NumFilter$, ExitKey%)
			Month1 = NUVAL(A$)
		   
			IF ClearNext THEN
				CALL KILLSTRING(Day1$)
			ELSE
				Day1$ = MID$(Date1$, 4, 2)
			END IF
			A$ = EDITOR$(StartRow% + 1, 12, 2, &H70, Day1$, NumFilter$, ExitKey%)
			Day1 = NUVAL(A$)
		   
			IF ClearNext THEN
				CALL KILLSTRING(YEAR1$)
			ELSE
				YEAR1$ = MID$(Date1$, 7, 4)
			END IF
			A$ = EDITOR$(StartRow% + 2, 12, 4, &H70, YEAR1$, NumFilter$, ExitKey%)
			YEAR1 = NUVAL(A$)

			'if enter 0 for Month or Day get current date
			IF (Month1% = 0) OR (Day1% = 0) THEN
				CALL CURRENTDATE(Month1%, Day1%, YEAR1%)
			END IF

			ClearNext = 0    'turn off toggle
		    
			JulDate1& = DATE2JUL&(Month1%, Day1%, YEAR1%)
			IF JulDate1& = 0& THEN
					CALL QPRT(StartRow% + 4, 3, InputErrMsg$)
					CALL MakeBeepSound
					GOTO ReStart1
			END IF
			'normalize year if entered Year 92 to mean 1992
			CALL JUL2DATE(Month1, Day1, YEAR1, JulDate1&)
			CALL PrintResults

		  CASE -60            'F2, input day two
ReStart2:
			IF ClearNext THEN
				CALL KILLSTRING(Month2$)
			ELSE
				Month2$ = MID$(Date2$, 1, 2)
			END IF
			A$ = EDITOR$(StartRow%, 12, 2, &H70, Month2$, NumFilter$, ExitKey%)
			Month2 = NUVAL(A$)
		    
			IF ClearNext THEN
				CALL KILLSTRING(Day2$)
			ELSE
				Day2$ = MID$(Date2$, 4, 2)
			END IF
			A$ = EDITOR$(StartRow% + 1, 12, 2, &H70, Day2$, NumFilter$, ExitKey%)
			Day2 = NUVAL(A$)
		    
			IF ClearNext THEN
				CALL KILLSTRING(Year2$)
			ELSE
				Year2$ = MID$(Date2$, 7, 4)
			END IF
			A$ = EDITOR$(StartRow% + 2, 12, 4, &H70, Year2$, NumFilter$, ExitKey%)
			Year2 = NUVAL(A$)

			'if enter 0 for Month or Day get current date
			IF (Month2% = 0) OR (Day2% = 0) THEN
				CALL CURRENTDATE(Month2%, Day2%, Year2%)
			END IF

			ClearNext = 0    'turn off toggle
		    
			JulDate2& = DATE2JUL&(Month2%, Day2%, Year2%)
			IF JulDate2& = 0& THEN
					CALL QPRT(StartRow% + 4, 3, InputErrMsg$)
					CALL MakeBeepSound
					GOTO ReStart2
			END IF
			'normalize year if entered Year 92 to mean 1992
			CALL JUL2DATE(Month2, Day2, Year2, JulDate2&)
			CALL PrintResults

		  CASE -61            'F3, input days between days
ReStart3:
			IF ClearNext THEN CALL KILLSTRING(OldDay$)
			A$ = EDITOR$(StartRow% + 3, 33, 8, &H70, OldDay$, NumFilter$, ExitKey%)
			DaysBtwnDate& = NUVAL(A$)
		    
			ClearNext = 0   'turn off toggle
		    
			'check the range of input
			IF ABS(DaysBtwnDate&) > 876581 THEN
					CALL QPRT(StartRow% + 4, 3, OutofRange$)
					CALL MakeBeepSound
					GOTO ReStart3
			END IF
			CALL PrintResults
		 
		  CASE -62          'F4, set clear next flag
			ClearNext = -1
		 
		  CASE -104           'ALT-F1, calc day one
			IF (DaysBtwnDate& = 0&) OR (JulDate2& = 0&) THEN
					CALL QPRT(StartRow% + 4, 3, TryAgainMsg$)
					GOTO Finish1
			END IF
			JulDate1& = JulDate2& - DaysBtwnDate&
			CALL JUL2DATE(Month1, Day1, YEAR1, JulDate1&)
			IF Month1 = 0 THEN
					CALL QPRT(StartRow% + 4, 3, OutofRange$)
					CALL MakeBeepSound
					GOTO Finish1
			END IF
			CALL PrintResults
Finish1:

		  CASE -105           'ALT-F2, calc day two
			IF (DaysBtwnDate& = 0&) OR (JulDate1& = 0&) THEN
					CALL QPRT(StartRow% + 4, 3, TryAgainMsg$)
					GOTO Finish2
			END IF
			JulDate2& = JulDate1& + DaysBtwnDate&
			CALL JUL2DATE(Month2, Day2, Year2, JulDate2&)
			IF Month2 = 0 THEN
					CALL QPRT(StartRow% + 4, 3, OutofRange$)
					CALL MakeBeepSound
					GOTO Finish2
			END IF
			CALL PrintResults
Finish2:

		  CASE -106           'ALT-F3, calc days between days
			IF (JulDate1& = 0) OR (JulDate2& = 0&) THEN
					CALL QPRT(StartRow% + 4, 3, TryAgainMsg$)
					GOTO Finish3
			END IF
			DaysBtwnDate& = JulDate2& - JulDate1&
			CALL PrintResults
Finish3:

			CASE ELSE
				CALL CLRKBD          'clear key buffer
				CALL MakeBeepSound   'indicate invalid key
				CALL PrintResults    'update display
				CALL CLRKBD          're-clear buffer
	 END SELECT
LOOP
    
'turn off clock, only necessary inside QB.EXE
InstallMode% = 0
CALL SHOWCLOCK(5, WBx(3).ULC + 5, 0, InstallMode%)
    
LOCATE 21, 1           'move cursor to bottom of display

'restore original numlock state
NumLk% = OrigNumLk%
CALL SETKBD(Insertk%, CapsLk%, NumLk%, ScrolK%)

END

'======================================================================
' Make a pleasant beep sound
' Updated: 01/06/92
'======================================================================
SUB MakeBeepSound STATIC
	CALL BEEPER10: CALL BEEPER20
END SUB

'=====================================================================
' Provides display of current values for all variables
' Updated: 09/07/93
'=====================================================================
SUB PrintResults STATIC

STATIC INITS, T$, T%, ErrArea$, YrPassed%, YearClr$

SHARED Date1$, Date2$
SHARED JulDate1&, Month1%, Day1%, YEAR1%, StartRow%, OldDay$
SHARED JulDate2&, Month2%, Day2%, Year2%, DaysBtwnDate&

	IF NOT INITS THEN  'do this only once
		DIM DayofWeek(-1 TO 6) AS STRING  'makes this a near array
			DayofWeek(0) = "Sunday   ": DayofWeek(-1) = "Invalid  "
			DayofWeek(1) = "Monday   ": DayofWeek(2) = "Tuesday  "
			DayofWeek(3) = "Wednesday": DayofWeek(4) = "Thursday "
			DayofWeek(5) = "Friday   ": DayofWeek(6) = "Saturday "
		INITS = -1
		T$ = SPACE$(14)  'clears a display area of days between dates
		YearClr$ = SPACE$(8)
		ErrArea$ = SPACE$(40)
	END IF

	 ' Clear any error messages
	CALL QPRT(StartRow% + 4, 3, ErrArea$)

	' Print the Starting Date Value and Day of Week
	Date1$ = DATE2STRING$(Month1%, Day1%, YEAR1%)
	CALL QPRT(WBx(1).ULR + 1, WBx(1).ULC + 2, Date1$)
	T% = WEEKDAYNUM%(JulDate1&)
	CALL QPRT(WBx(1).ULR + 2, WBx(1).ULC + 2, DayofWeek(T%))

	' Print the Ending Date Value and Day of Week
	Date2$ = DATE2STRING$(Month2%, Day2%, Year2%)
	CALL QPRT(WBx(2).ULR + 1, WBx(2).ULC + 2, Date2$)
	T% = WEEKDAYNUM%(JulDate2&)
	CALL QPRT(WBx(2).ULR + 2, WBx(2).ULC + 2, DayofWeek(T%))

	' Print Days between Dates number
	'erase old value
	CALL QPRT(WBx(3).ULR + 1, WBx(3).ULC + 3, T$)
	CALL QPRT(WBx(3).ULR + 2, WBx(3).ULC + 3, YearClr$)
    
	'format new value
	OldDay$ = FORMATNUMLEFT$(STR$(DaysBtwnDate&))

	'print new value
	CALL QPRT(WBx(3).ULR + 1, WBx(3).ULC + 3, OldDay$)
    
	'calc aprox num years rounded down to next lower integer
	YrPassed% = DaysBtwnDate& \ 365
	YrPassed$ = FORMATNUMLEFT$(STR$(YrPassed%))
	CALL QPRT(WBx(3).ULR + 2, WBx(3).ULC + 3, YrPassed$)

END SUB

'======================================================================
' Displays a 6 month array around the current date
' Assumes the machine clock is accurate
' Updated 9/09/93
'======================================================================
SUB ShowCalendar
    
	SHARED ATTRIB, ClrAttrib%

	CALL CURRENTDATE(MONTH%, x, YEAR1)
	IF YEAR1 < 1992 THEN EXIT SUB  'if machine clock not accurate, quit

	T5$ = " Press a Key to Continue. "
	CALL QPRINT(2, 28, T5$, ATTRIB%)          'print message
	CALL KILLSTRING(T5$)                      'save some string space
    
	Row = 3: Col = 4: MONTH = MONTH - 1: GOSUB MonthAdj
	CALL MAKECAL(Row%, Col%, MONTH%, YEAR1, &H70, ClrAttrib%)

	Row = 3: Col = 29: MONTH = MONTH + 1: GOSUB MonthAdj
	CALL MAKECAL(Row%, Col%, MONTH%, YEAR1, &H70, ClrAttrib%)

	Row = 3: Col = 54: MONTH = MONTH + 1: GOSUB MonthAdj
	CALL MAKECAL(Row%, Col%, MONTH%, YEAR1, &H70, ClrAttrib%)

	Row = 14: Col = 4: MONTH = MONTH + 1: GOSUB MonthAdj
	CALL MAKECAL(Row%, Col%, MONTH%, YEAR1, &H70, ClrAttrib%)

	Row = 14: Col = 29: MONTH = MONTH + 1: GOSUB MonthAdj
	CALL MAKECAL(Row%, Col%, MONTH%, YEAR1, &H70, ClrAttrib%)

	Row = 14: Col = 54: MONTH = MONTH + 1: GOSUB MonthAdj
	CALL MAKECAL(Row%, Col%, MONTH%, YEAR1, &H70, ClrAttrib%)
    
	CALL CLRKBD     'clear buffer
    
	DO  'wait for a keystroke to quit
		KeyItem% = WAITFORKEY%
	LOOP UNTIL KeyItem% > -256
    
	EXIT SUB

MonthAdj:
	'This keeps month within range
	
	SELECT CASE MONTH
		CASE IS < 1
			MONTH = 12
			YEAR1 = YEAR1 - 1
		CASE IS > 12
			MONTH = 1
			YEAR1 = YEAR1 + 1
		CASE ELSE
	END SELECT
	RETURN

END SUB

